#include <stdio.h>

//funkcija koja mijenja vrijednosti ulaznim parametrima
//funkciji se predavaju adrese varijabli iz glavnog programa
//tako da se u ulazne parametre koji su definirani pokazivaima x i y
//spreamju adrese variajbli a i b iz glavnog programa
//radi toga su promjene u funkciji vidljive i u glavnom programu
void zamjena(int *x, int *y){
    //deklaracija pomone varijable
    int pom;
    //pridruivanje vrijednosti varijable x pomonoj varijabli pom
    //pridruivanje vrijednosti varijable y varijabli x
    //pridruivanje vrijednosti pomone varijable pom varijabli y
    pom = *x;
    *x = *y;
    *y = pom;

}

//funkcija za ispis elemenata polja
void ispis(int *polje, int brel){
	int i;
	for(i=0; i<brel; i++)
	   //moglo se pisati i printf("%d ", polje[i]);
		printf("%d ", *(polje+i));
	printf("\n");
}

//funkcija za sortiranje odabirom (selection sort)
void selection_sort(int *polje, int brel){
	int i, j, min;
	//prva for petlja odreiva od kojeg elementa kreemo sa soritranjem
	for(i=0; i < brel; i++){
        min = i;
		//u drugoj for petlji se ispisuje polje i usporeivaju elementi
		for(j=i+1; j < brel; j++){
            //trai se da li postoji manji element od trenutnog
            //moglo se pisati i if (polje[j] < polje[min])
			if(*(polje + j) < *(polje + min))
                //minimalni indeks postaje indeks najmanjeg elementa u preostalom dijelu polja
                min = j;
		}
        //ako jest poziva se funkcija za zamjenu
        //moglo se pisati i zamjena(&polje[j], &polje[min]);
        zamjena(polje + i, polje + min);
        ispis(polje, brel);
	}
}
int main(){
	int i, n;
	//deklaracija polja koje moe sadravati najvie 50 cijelih brojeva
	int polje[50];
	//unos stvarnog broja elemenata polja kojeg elimo sortirati
	printf("Unesite broj elemenata polja kojeg zelite sortirati: ");
	scanf("%d", &n);
	//unos elemenata polja
	printf("Unesite polje cijelih brojeva: ");
	for(i=0; i<n; i++)
		scanf("%d", &polje[i]);
	printf("\n");

	//poziv funkcije za sortiranje
	selection_sort(polje, n);
	printf("Sortirano polje: ");
	ispis(polje, n);

    system("pause");
	return 0;
}
